Skip to main content
PUT
/
subscriptions
/
{external_id}
/
charges
/
{charge_code}
Override a charge for a subscription
curl --request PUT \
  --url https://api.getlago.com/api/v1/subscriptions/{external_id}/charges/{charge_code} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "charge": {
    "invoice_display_name": "Setup",
    "min_amount_cents": 0,
    "properties": {
      "grouped_by": [
        "agent_name"
      ],
      "pricing_group_keys": [
        "agent_name"
      ],
      "graduated_ranges": [
        {
          "from_value": 0,
          "to_value": 10,
          "flat_amount": "10",
          "per_unit_amount": "0.5"
        }
      ],
      "graduated_percentage_ranges": [
        {
          "from_value": 0,
          "to_value": 10,
          "rate": "1",
          "flat_amount": "10"
        }
      ],
      "amount": "30",
      "free_units": 100,
      "package_size": 1000,
      "rate": "1",
      "fixed_amount": "0.5",
      "free_units_per_events": 5,
      "free_units_per_total_aggregation": "500",
      "per_transaction_max_amount": "3.75",
      "per_transaction_min_amount": "1.75",
      "volume_ranges": [
        {
          "from_value": 0,
          "to_value": 10,
          "flat_amount": "10",
          "per_unit_amount": "0.5"
        }
      ],
      "presentation_group_keys": [
        {
          "value": "region",
          "options": {
            "display_in_invoice": true
          }
        }
      ]
    },
    "filters": [
      {
        "properties": {
          "grouped_by": [
            "agent_name"
          ],
          "pricing_group_keys": [
            "agent_name"
          ],
          "graduated_ranges": [
            {
              "from_value": 0,
              "to_value": 10,
              "flat_amount": "10",
              "per_unit_amount": "0.5"
            }
          ],
          "graduated_percentage_ranges": [
            {
              "from_value": 0,
              "to_value": 10,
              "rate": "1",
              "flat_amount": "10"
            }
          ],
          "amount": "30",
          "free_units": 100,
          "package_size": 1000,
          "rate": "1",
          "fixed_amount": "0.5",
          "free_units_per_events": 5,
          "free_units_per_total_aggregation": "500",
          "per_transaction_max_amount": "3.75",
          "per_transaction_min_amount": "1.75",
          "volume_ranges": [
            {
              "from_value": 0,
              "to_value": 10,
              "flat_amount": "10",
              "per_unit_amount": "0.5"
            }
          ]
        },
        "values": {
          "region": [
            "us-east-1"
          ]
        },
        "invoice_display_name": "AWS"
      }
    ],
    "tax_codes": [
      "french_standard_vat"
    ],
    "applied_pricing_unit": {
      "code": "credits",
      "conversion_rate": "0.5"
    }
  }
}
'
import requests

url = "https://api.getlago.com/api/v1/subscriptions/{external_id}/charges/{charge_code}"

payload = { "charge": {
        "invoice_display_name": "Setup",
        "min_amount_cents": 0,
        "properties": {
            "grouped_by": ["agent_name"],
            "pricing_group_keys": ["agent_name"],
            "graduated_ranges": [
                {
                    "from_value": 0,
                    "to_value": 10,
                    "flat_amount": "10",
                    "per_unit_amount": "0.5"
                }
            ],
            "graduated_percentage_ranges": [
                {
                    "from_value": 0,
                    "to_value": 10,
                    "rate": "1",
                    "flat_amount": "10"
                }
            ],
            "amount": "30",
            "free_units": 100,
            "package_size": 1000,
            "rate": "1",
            "fixed_amount": "0.5",
            "free_units_per_events": 5,
            "free_units_per_total_aggregation": "500",
            "per_transaction_max_amount": "3.75",
            "per_transaction_min_amount": "1.75",
            "volume_ranges": [
                {
                    "from_value": 0,
                    "to_value": 10,
                    "flat_amount": "10",
                    "per_unit_amount": "0.5"
                }
            ],
            "presentation_group_keys": [
                {
                    "value": "region",
                    "options": { "display_in_invoice": True }
                }
            ]
        },
        "filters": [
            {
                "properties": {
                    "grouped_by": ["agent_name"],
                    "pricing_group_keys": ["agent_name"],
                    "graduated_ranges": [
                        {
                            "from_value": 0,
                            "to_value": 10,
                            "flat_amount": "10",
                            "per_unit_amount": "0.5"
                        }
                    ],
                    "graduated_percentage_ranges": [
                        {
                            "from_value": 0,
                            "to_value": 10,
                            "rate": "1",
                            "flat_amount": "10"
                        }
                    ],
                    "amount": "30",
                    "free_units": 100,
                    "package_size": 1000,
                    "rate": "1",
                    "fixed_amount": "0.5",
                    "free_units_per_events": 5,
                    "free_units_per_total_aggregation": "500",
                    "per_transaction_max_amount": "3.75",
                    "per_transaction_min_amount": "1.75",
                    "volume_ranges": [
                        {
                            "from_value": 0,
                            "to_value": 10,
                            "flat_amount": "10",
                            "per_unit_amount": "0.5"
                        }
                    ]
                },
                "values": { "region": ["us-east-1"] },
                "invoice_display_name": "AWS"
            }
        ],
        "tax_codes": ["french_standard_vat"],
        "applied_pricing_unit": {
            "code": "credits",
            "conversion_rate": "0.5"
        }
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    charge: {
      invoice_display_name: 'Setup',
      min_amount_cents: 0,
      properties: {
        grouped_by: ['agent_name'],
        pricing_group_keys: ['agent_name'],
        graduated_ranges: [{from_value: 0, to_value: 10, flat_amount: '10', per_unit_amount: '0.5'}],
        graduated_percentage_ranges: [{from_value: 0, to_value: 10, rate: '1', flat_amount: '10'}],
        amount: '30',
        free_units: 100,
        package_size: 1000,
        rate: '1',
        fixed_amount: '0.5',
        free_units_per_events: 5,
        free_units_per_total_aggregation: '500',
        per_transaction_max_amount: '3.75',
        per_transaction_min_amount: '1.75',
        volume_ranges: [{from_value: 0, to_value: 10, flat_amount: '10', per_unit_amount: '0.5'}],
        presentation_group_keys: [{value: 'region', options: {display_in_invoice: true}}]
      },
      filters: [
        {
          properties: {
            grouped_by: ['agent_name'],
            pricing_group_keys: ['agent_name'],
            graduated_ranges: [{from_value: 0, to_value: 10, flat_amount: '10', per_unit_amount: '0.5'}],
            graduated_percentage_ranges: [{from_value: 0, to_value: 10, rate: '1', flat_amount: '10'}],
            amount: '30',
            free_units: 100,
            package_size: 1000,
            rate: '1',
            fixed_amount: '0.5',
            free_units_per_events: 5,
            free_units_per_total_aggregation: '500',
            per_transaction_max_amount: '3.75',
            per_transaction_min_amount: '1.75',
            volume_ranges: [{from_value: 0, to_value: 10, flat_amount: '10', per_unit_amount: '0.5'}]
          },
          values: {region: ['us-east-1']},
          invoice_display_name: 'AWS'
        }
      ],
      tax_codes: ['french_standard_vat'],
      applied_pricing_unit: {code: 'credits', conversion_rate: '0.5'}
    }
  })
};

fetch('https://api.getlago.com/api/v1/subscriptions/{external_id}/charges/{charge_code}', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));


{
  "charge": {
    "lago_id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
    "lago_billable_metric_id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
    "billable_metric_code": "requests",
    "created_at": "2022-09-14T16:35:31Z",
    "pay_in_advance": true,
    "invoiceable": true,
    "regroup_paid_fees": "invoice",
    "prorated": false,
    "min_amount_cents": 1200,
    "properties": {
      "grouped_by": [
        "agent_name"
      ],
      "pricing_group_keys": [
        "agent_name"
      ],
      "graduated_ranges": [
        {
          "from_value": 0,
          "to_value": 10,
          "flat_amount": "10",
          "per_unit_amount": "0.5"
        }
      ],
      "graduated_percentage_ranges": [
        {
          "from_value": 0,
          "to_value": 10,
          "rate": "1",
          "flat_amount": "10"
        }
      ],
      "amount": "30",
      "free_units": 100,
      "package_size": 1000,
      "rate": "1",
      "fixed_amount": "0.5",
      "free_units_per_events": 5,
      "free_units_per_total_aggregation": "500",
      "per_transaction_max_amount": "3.75",
      "per_transaction_min_amount": "1.75",
      "volume_ranges": [
        {
          "from_value": 0,
          "to_value": 10,
          "flat_amount": "10",
          "per_unit_amount": "0.5"
        }
      ],
      "presentation_group_keys": [
        {
          "value": "region",
          "options": {
            "display_in_invoice": true
          }
        }
      ]
    },
    "filters": [
      {
        "invoice_display_name": "AWS",
        "properties": {
          "grouped_by": [
            "agent_name"
          ],
          "pricing_group_keys": [
            "agent_name"
          ],
          "graduated_ranges": [
            {
              "from_value": 0,
              "to_value": 10,
              "flat_amount": "10",
              "per_unit_amount": "0.5"
            }
          ],
          "graduated_percentage_ranges": [
            {
              "from_value": 0,
              "to_value": 10,
              "rate": "1",
              "flat_amount": "10"
            }
          ],
          "amount": "30",
          "free_units": 100,
          "package_size": 1000,
          "rate": "1",
          "fixed_amount": "0.5",
          "free_units_per_events": 5,
          "free_units_per_total_aggregation": "500",
          "per_transaction_max_amount": "3.75",
          "per_transaction_min_amount": "1.75",
          "volume_ranges": [
            {
              "from_value": 0,
              "to_value": 10,
              "flat_amount": "10",
              "per_unit_amount": "0.5"
            }
          ]
        },
        "values": {
          "region": [
            "us-east-1"
          ]
        }
      }
    ],
    "code": "api_requests_charge",
    "invoice_display_name": "Setup",
    "taxes": [
      {
        "lago_id": "1a901a90-1a90-1a90-1a90-1a901a901a90",
        "name": "TVA",
        "code": "french_standard_vat",
        "rate": 20,
        "applied_to_organization": true,
        "created_at": "2023-07-06T14:35:58Z",
        "description": "French standard VAT"
      }
    ],
    "applied_pricing_unit": {
      "code": "unit_code",
      "conversion_rate": "0.5"
    },
    "accepts_target_wallet": false,
    "lago_parent_id": "1a901a90-1a90-1a90-1a90-1a901a901a90"
  }
}
{
  "status": 400,
  "error": "Bad request"
}
{
  "status": 401,
  "error": "Unauthorized"
}
{
  "status": 403,
  "error": "Forbidden",
  "code": "feature_unavailable"
}
{
  "status": 404,
  "error": "Not Found",
  "code": "object_not_found"
}
{
  "status": 422,
  "error": "Unprocessable entity",
  "code": "validation_errors",
  "error_details": {}
}

Authorizations

Authorization
string
header
required

Bearer authentication header of the form Bearer <token>, where <token> is your auth token.

Path Parameters

external_id
string
required

External ID of the existing subscription.

Example:

"sub_1234567890"

charge_code
string
required

Code of the existing charge.

Example:

"api_requests_charge"

Query Parameters

subscription_status
enum<string>
default:active

Filter by subscription status. When provided, the subscription is looked up with this status instead of the default active status. Possible values are pending, active, terminated, or canceled.

Available options:
pending,
active,
terminated,
canceled
Example:

"active"

Body

application/json

Charge override payload

charge
object
required

Properties of a charge that can be overridden at the subscription level.

Response

Charge override created or updated

charge
object
required